#version 330 core

// Input vertex data, different for all executions of this shader.
layout(location = 0) in vec3 vertexPosition_modelspace;
layout(location = 1) in vec3 vertexNormals;
layout(location = 2) in vec2 uvs;
layout(location = 3) in vec2 vertexPosition_screenspace;

//output
out vec2 fragmentUvs;
smooth out vec3 fragmentNormals;
out vec3 fragmentView;
out vec3 fragmentPosition;
//out uint fragmentMode;

//input
//uniform mat4 mvp;
uniform mat4 view;
uniform mat4 projection;
uniform mat4 model;
uniform vec3 lightPosition;
uniform vec3 cameraPosition;

//changing shaders in code is apparently costly
//here's a uniform that tells the shader what to shade
uniform int mode; //0=3d world and lightning, 1=text (hud, start game and stuff), 2=normals
uniform vec2 screenResolution;

void main()
{
	
	if(mode == 0){
		// Calculate the position of the vertex against the world, view, and projection matrices.
		vec4 position = model * vec4(vertexPosition_modelspace, 1.0f);
		position = view * position;
		gl_Position = projection * position;


	
		fragmentLightDirection = lightPosition - vec3(position);   
		fragmentNormals = vertexNormals;
		fragmentUvs = uvs;
		fragmentEyeDirection = vec3(- position);
		fragmentNormals = vec3(model * vec4(vertexNormals,0));
	
		smooth out vec3 fragmentNormals;
		out vec3 fragmentView;
		out vec3 fragmentPosition;	
	}
	if(mode == 2){
		gl_Position = projection * view * model * vec4(vertexPosition_modelspace,1);
		fragmentNormals = vertexNormals;
	}
}