#version 330 core

//vertex input
in vec2 fragmentUvs;
smooth in vec3 fragmentNormals;
in vec3 fragmentEyeDirection;
in vec3 fragmentLightDirection;
//in uint fragmentMode;

//uniforms from main program
uniform sampler2D	colorTexture;
uniform vec3	lightPosition;
uniform vec3	lightColor; //sunlight color might be a nice touch
uniform float	lightPower;
uniform float	material_shininess;
uniform int		mode;
//uniform uint mode; //0=3d world and lightning, 1=text (hud, start game and stuff), 3=normals


//pixelcolor
out vec4 color;


//forward declaration
vec4 celshade(in float intensity, in vec4 color);
vec3 celshade(in float intensity);

float intensityCel(in float intensity);

vec4 blur(in vec2 uv);

//TODO: make modules, length is getting ridiculous
void main()
{ 	
	if (mode == 0)
	{
		vec3 textureColor = texture2D( colorTexture, fragmentUvs ).rgb;
		float ambientCoeffiecient = .05;

		//differenc colors
		//low ambientcolor
		vec3 ambientColor = vec3(1.0,0.0,0.0) * ambientCoeffiecient;
		vec3 color3;

		//get directional components for shading
		vec3 n = normalize(fragmentNormals);
		vec3 l = normalize(fragmentLightDirection);
		vec3 e = normalize(fragmentEyeDirection);
		vec3 r = normalize(-reflect(l,n));

		//calculate Ambient Term:  
		vec3 Iamb = ambientColor;    

		//calculate Diffuse Term:  
		vec3 Idiff = lightPower * lightColor * max(dot(n,l), 0.0);
		Idiff = clamp(Idiff, 0.0, 1.0);     
   
	   // calculate Specular Term:
	   vec3 Ispec = vec3(1,1,1) * pow(max(dot(r,e),0.0), 0.3*material_shininess) * 0.4;
	   Ispec = clamp(Ispec, 0.0, 1.0); 


		color3 = Iamb + Idiff + Ispec;
		//color3 = clamp(color3, 0.0, 1.0);  
		color3 = color3 * textureColor;

		color = vec4(color3,1);	
		//color = vec4(textureColor,1); //clamp(color, 0.0f, 1.0f);

	}
	if (mode == 2)
	{
		color = vec4 (fragmentNormals,1);
		//normalsShader();
	}
}